TEMPLATE = app
TARGET = CrabEmu
CONFIG += release qt thread
LIBS = -lopenal
mac:LIBS = -framework OpenAL

PREFIX = /usr

DEFINES += IN_CRABEMU \
           CRABZ80_NO_READMAP_FALLBACK

DEPENDPATH += . \
              src \
              src/qt \
              src/sound \
              src/consoles/sms \
              src/cpu/CrabZ80 \
              src/qt/gui \
              src/qt/resources \
              src/sound/openal

INCLUDEPATH += . \
               src/consoles/sms \
               src \
               src/sound \
               src/qt \
               src/qt/gui \
               src/cpu/CrabZ80

HEADERS += src/CrabEmu.h \
           src/qt/CrabEmuThread.h \
           src/qt/EmuWidget.h \
           src/sound/sn76489.h \
           src/sound/sound.h \
           src/consoles/sms/93c46.h \
           src/consoles/sms/mappers.h \
           src/consoles/sms/sms.h \
           src/consoles/sms/smsmem.h \
           src/consoles/sms/smsmem-gg.h \
           src/consoles/sms/smsvcnt.h \
           src/consoles/sms/smsvdp.h \
           src/consoles/sms/smsz80.h \
           src/consoles/sms/terebi.h \
           src/consoles/sms/tms9918a.h \
           src/consoles/sms/mapper-93c46.h \
           src/consoles/sms/mapper-korean.h \
           src/consoles/sms/mapper-codemasters.h \
           src/consoles/sms/mapper-sega.h \
           src/consoles/sms/mapper-sg1000.h \
           src/cpu/CrabZ80/CrabZ80.h \
           src/cpu/CrabZ80/CrabZ80_macros.h \
           src/cpu/CrabZ80/CrabZ80_tables.h \
           src/cpu/CrabZ80/CrabZ80d.h \
           src/cpu/CrabZ80/CrabZ80ops.h \
           src/cpu/CrabZ80/CrabZ80opsCB.h \
           src/cpu/CrabZ80/CrabZ80opsDD-FD.h \
           src/cpu/CrabZ80/CrabZ80opsDDCB-FDCB.h \
           src/cpu/CrabZ80/CrabZ80opsED.h \
           src/qt/gui/UIAboutDialog.h \
           src/qt/gui/UICrabEmu.h \
           src/qt/gui/UIKeyInputDialog.h \
           src/qt/gui/UIPreferences.h

FORMS += src/qt/gui/AboutDialog.ui \
         src/qt/gui/CrabEmu.ui \
         src/qt/gui/KeyInputDialog.ui \
         src/qt/gui/Preferences.ui

SOURCES += src/qt/CrabEmuThread.cpp \
           src/qt/EmuWidget.cpp \
           src/qt/main.cpp \
           src/sound/sn76489.c \
           src/consoles/sms/93c46.c \
           src/consoles/sms/mappers.c \
           src/consoles/sms/sms.c \
           src/consoles/sms/smsmem.c \
           src/consoles/sms/smsmem-gg.c \
           src/consoles/sms/smsvdp.c \
           src/consoles/sms/smsz80.c \
           src/consoles/sms/terebi.c \
           src/consoles/sms/tms9918a.c \
           src/consoles/sms/mapper-93c46.c \
           src/consoles/sms/mapper-korean.c \
           src/consoles/sms/mapper-codemasters.c \
           src/consoles/sms/mapper-sega.c \
           src/consoles/sms/mapper-sg1000.c \
           src/cpu/CrabZ80/CrabZ80.c \
           src/cpu/CrabZ80/CrabZ80d.c \
           src/qt/gui/UIAboutDialog.cpp \
           src/qt/gui/UICrabEmu.cpp \
           src/qt/gui/UIKeyInputDialog.cpp \
           src/qt/gui/UIPreferences.cpp \
           src/sound/openal/sound.c

RESOURCES += src/qt/resources/CrabEmu.qrc

INSTALLS += target
target.path = $$PREFIX/bin
