/*
	This file is part of CrabEmu.

	Copyright (C) 2006 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 
    as published by the Free Software Foundation.

	CrabEmu is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CrabEmu; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "ClickableImageView.h"
#include "EmuController.h"

@implementation ClickableImageView

- (void)mouseDown:(NSEvent *)theEvent
{
    NSPoint location = [self convertPoint: [theEvent locationInWindow] fromView: nil];
    int x, y;
    unichar key = 0xFF;

    x = (int) location.x - 20;
    y = (int) location.y - 6;

    switch(y / 20)  {
        case 0:
        {
            if(x < 86)
                key = 0xFF;
            else if(x < 214)
                key = 0x31;
            else if(x < 310)
                key = 0xFF;
            else if(x < 330)
                key = 0x7B;
            else if(x < 350)
                key = 0x7D;
            else if(x < 370)
                key = 0x7C;
            else if(x < 380)
                key = 0xFF;
            else if(x < 420)
                key = 0x52;
            else if(x < 440)
                key = 0x41;
            else if(x < 460)
                key = 0x4C;
            else
                key = 0xFF;
            break;
        }
        case 1:
        {
            if(x < 0)
                key = 0xFF;
            else if(x < 50)
                key = 0x38;
            else if(x < 70)
                key = 0x06;
            else if(x < 90)
                key = 0x07;
            else if(x < 110)
                key = 0x08;
            else if(x < 130)
                key = 0x09;
            else if(x < 150)
                key = 0x0B;
            else if(x < 170)
                key = 0x2D;
            else if(x < 190)
                key = 0x2E;
            else if(x < 210)
                key = 0x2B;
            else if(x < 230)
                key = 0x2F;
            else if(x < 250)
                key = 0x2C;
            else if(x < 300)
                key = 0x3C;
            else if(x < 330)
                key = 0xFF;
            else if(x < 350)
                key = 0x7E;
            else if(x < 380)
                key = 0xFF;
            else if(x < 400)
                key = 0x53;
            else if(x < 420)
                key = 0x54;
            else if(x < 440)
                key = 0x55;
            else if(x < 460)
                key = 0x4C;
            else
                key = 0xFF;

            break;
        }
        case 2:
        {
            if(x < 40)
                key = 0xFF;
            else if(x < 60)
                key = 0x00;
            else if(x < 80)
                key = 0x01;
            else if(x < 100)
                key = 0x02;
            else if(x < 120)
                key = 0x03;
            else if(x < 140)
                key = 0x05;
            else if(x < 160)
                key = 0x04;
            else if(x < 180)
                key = 0x26;
            else if(x < 200)
                key = 0x28;
            else if(x < 220)
                key = 0x25;
            else if(x < 240)
                key = 0x29;
            else if(x < 260)
                key = 0x27;
            else if(x < 300)
                key = 0x24;
            else if(x < 380)
                key = 0xFF;
            else if(x < 400)
                key = 0x56;
            else if(x < 420)
                key = 0x57;
            else if(x < 440)
                key = 0x58;
            else if(x < 460)
                key = 0x45;
            else
                key = 0xFF;

            break;
        }
        case 3:
        {
            if(x < 0)
                key = 0xFF;
            else if(x < 30)
                key = 0x30;
            else if(x < 50)
                key = 0x0C;
            else if(x < 70)
                key = 0x0D;
            else if(x < 90)
                key = 0x0E;
            else if(x < 110)
                key = 0x0F;
            else if(x < 130)
                key = 0x11;
            else if(x < 150)
                key = 0x10;
            else if(x < 170)
                key = 0x20;
            else if(x < 190)
                key = 0x22;
            else if(x < 210)
                key = 0x1F;
            else if(x < 230)
                key = 0x23;
            else if(x < 250)
                key = 0x21;
            else if(x < 270)
                key = 0x1E;
            else if(x < 300)
                key = 0x21;
            else if(x < 310)
                key = 0xFF;
            else if(x < 330)
                key = 0x75;
            else if(x < 350)
                key = 0x77;
            else if(x < 370)
                key = 0x79;
            else if(x < 380)
                key = 0xFF;
            else if(x < 400)
                key = 0x59;
            else if(x < 420)
                key = 0x5B;
            else if(x < 440)
                key = 0x5C;
            else if(x < 460)
                key = 0x4E;
            else
                key = 0xFF;

            break;
        }
        case 4:
        {
            if(x < 0)
                key = 0xFF;
            else if(x < 20)
                key = 0x32;
            else if(x < 40)
                key = 0x12;
            else if(x < 60)
                key = 0x13;
            else if(x < 80)
                key = 0x14;
            else if(x < 100)
                key = 0x15;
            else if(x < 120)
                key = 0x17;
            else if(x < 140)
                key = 0x16;
            else if(x < 160)
                key = 0x1A;
            else if(x < 180)
                key = 0x1C;
            else if(x < 200)
                key = 0x19;
            else if(x < 220)
                key = 0x1D;
            else if(x < 240)
                key = 0x1B;
            else if(x < 260)
                key = 0x18;
            else if(x < 300)
                key = 0x33;
            else if(x < 330)
                key = 0xFF;
            else if(x < 350)
                key = 0x73;
            else if(x < 370)
                key = 0x74;
            else if(x < 380)
                key = 0xFF;
            else if(x < 400)
                key = 0x47;
            else if(x < 420)
                key = 0x51;
            else if(x < 440)
                key = 0x4B;
            else if(x < 460)
                key = 0x43;
            else
                key = 0xFF;
            break;
        }
        case 5:
        {
            if(x < 0)
                key = 0xFF;
            else if(x < 30)
                key = 0x35;
            else if(x < 50)
                key = 0x7A;
            else if(x < 70)
                key = 0x78;
            else if(x < 90)
                key = 0x63;
            else if(x < 110)
                key = 0x76;
            else if(x < 130)
                key = 0x60;
            else if(x < 150)
                key = 0x61;
            else if(x < 170)
                key = 0x62;
            else if(x < 190)
                key = 0x64;
           else if(x < 270)
                key = 0xFF;
            else if(x < 300)
                key = 0x69;
            else if(x < 310)
                key = 0xFF;
            else if(x < 350)
                key = 0xFF;
            else if(x < 370)
                key = 0x6A;
            else
                key = 0xFF;

            break;
        }
        default:
            key = 0xFF;
    }

    if(key == 0xFF)    {
        [super mouseDown:theEvent];
        return;
    }

    [controller endVirtKeyboard:key];
}

@end
