/*
    This file is part of CrabEmu.

    Copyright (C) 2009 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef UICRABEMU_H
#define UICRABEMU_H

#include "ui_CrabEmu.h"
#include "CrabEmuThread.h"

class EmuWidget;

class UICrabEmu : public QMainWindow, public Ui::CrabEmu    {
    Q_OBJECT

    public:
        UICrabEmu(QWidget *parent = NULL);
        EmuWidget *emuwidget;
        CrabEmuThread *thread();

    protected:
        void keyPressEvent(QKeyEvent *e);
        void keyReleaseEvent(QKeyEvent *e);

    protected slots:
        void on_actionOpenRom_triggered();
        void on_actionSaveSRAM_triggered();

        void on_actionSaveSlot1_triggered();
        void on_actionSaveSlot2_triggered();
        void on_actionSaveSlot3_triggered();
        void on_actionSaveSlot4_triggered();
        void on_actionSaveSlot5_triggered();
        void on_actionSaveSlot6_triggered();

        void on_actionLoadSlot1_triggered();
        void on_actionLoadSlot2_triggered();
        void on_actionLoadSlot3_triggered();
        void on_actionLoadSlot4_triggered();
        void on_actionLoadSlot5_triggered();
        void on_actionLoadSlot6_triggered();

        void on_actionTakeScreenshot_triggered();

        void on_actionExit_triggered();

        void on_actionEnablePSG_triggered();
        void on_actionTone0_triggered();
        void on_actionTone1_triggered();
        void on_actionTone2_triggered();
        void on_actionNoise_triggered();

        void on_actionExport_triggered();
        void on_actionDomestic_triggered();

        void on_actionNTSC_triggered();
        void on_actionPAL_triggered();

        void on_actionPause_triggered();
        void on_actionReset_triggered();
        void on_actionPreferences_triggered();

        void on_actionAbout_triggered();

    private:
        QString openRom;
        CrabEmuThread *thd;
        bool paused;
        int region;
        int videoSystem;

        void initializeSettings();
};

#endif /* !UICRABEMU_H */
