/*
    This file is part of CrabEmu.

    Copyright (C) 2009 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef UIPREFERENCES_H
#define UIPREFERENCES_H

#include <QSettings>

#include "ui_Preferences.h"

class UIPreferences : public QDialog, public Ui::PreferencesDialog  {
    Q_OBJECT

    public:
        UIPreferences(QWidget *parent = NULL);
        void updatePreferences();

    protected slots:
        void on_buttonSMS1Up_clicked();
        void on_buttonSMS1Down_clicked();
        void on_buttonSMS1Left_clicked();
        void on_buttonSMS1Right_clicked();
        void on_buttonSMS1A_clicked();
        void on_buttonSMS1B_clicked();

        void on_buttonSMS2Up_clicked();
        void on_buttonSMS2Down_clicked();
        void on_buttonSMS2Left_clicked();
        void on_buttonSMS2Right_clicked();
        void on_buttonSMS2A_clicked();
        void on_buttonSMS2B_clicked();

        void on_buttonGGStart_clicked();

        void on_buttonBrowseSMSBios_clicked();
        void on_buttonBrowseGGBios_clicked();

    private:
        int getKeyInput();
        void setKey(const char *buttonmap, const char *button, int key);

        QVariantMap bm;
};

#endif /* !UIPREFERENCES_H */
